 
#include	"common.h"
#include	"pc1360.h"

#include	"Inter.h"
//#include	"debug.h"
#include	"Keyb.h"
#include	"Log.h"


void	Cpc1360::initExtension(void)
{
	
	// initialise ext_MemSlot1
	ext_MemSlot1 = new CExtensionArray("Memory Slot 1","Add memory credit card");
	ext_MemSlot1->setAvailable(ID_CE210M,true);		ext_MemSlot1->setChecked(ID_CE2H32M,true);
	ext_MemSlot1->setAvailable(ID_CE211M,true);
	ext_MemSlot1->setAvailable(ID_CE212M,true);
	ext_MemSlot1->setAvailable(ID_CE2H16M,true);
	ext_MemSlot1->setAvailable(ID_CE2H32M,true);
	ext_MemSlot1->setAvailable(ID_CE2H64M,true);

	// initialise ext_MemSlot2
	ext_MemSlot2 = new CExtensionArray("Memory Slot 2","Add memory credit card");
	ext_MemSlot2->setAvailable(ID_CE210M,true);		ext_MemSlot2->setChecked(ID_CE2H32M,false);
	ext_MemSlot2->setAvailable(ID_CE211M,true);
	ext_MemSlot2->setAvailable(ID_CE212M,true);
	ext_MemSlot2->setAvailable(ID_CE2H16M,true);
	ext_MemSlot2->setAvailable(ID_CE2H32M,true);
	ext_MemSlot2->setAvailable(ID_CE2H64M,true);
	
	addExtMenu(ext_MemSlot1);
	addExtMenu(ext_MemSlot2);
	
}


// PIN_MT_OUT2	1
// PIN_GND		2
// PIN_VGG		3
// PIN_BUSY		4
// PIN_D_OUT	5
// PIN_MT_IN	6
// PIN_MT_OUT1	7
// PIN_D_IN		8
// PIN_ACK		9
// PIN_SEL2		10
// PIN_SEL1		11
//#define GET_PORT_BIT(Port,Bit) ((Get_Port(Port) & (1<<((Bit)-1))) ? 1:0)
#define SIO_GNDP	1
#define SIO_SD 		2
#define SIO_RD		3
#define SIO_RS		4
#define SIO_CS		5

#define SIO_GND		7
#define SIO_CD		8
#define SIO_VC1		10
#define SIO_RR		11
#define SIO_PAK		12
#define SIO_VC2		13
#define SIO_ER		14
#define SIO_PRQ		15

bool Cpc1360::Set_Connector(void)
{
	int port1 = Get_8(0x3800);
	int port2 = Get_8(0x3A00);
	
	pCONNECTOR->Set_pin(PIN_MT_OUT2	,0);
	pCONNECTOR->Set_pin(PIN_VGG		,1);
	pCONNECTOR->Set_pin(PIN_BUSY	,READ_BIT(port1,0));
	pCONNECTOR->Set_pin(PIN_D_OUT	,READ_BIT(port2,2));
	pCONNECTOR->Set_pin(PIN_D_IN	,READ_BIT(port1,3));
	pCONNECTOR->Set_pin(PIN_SEL2	,READ_BIT(port2,1));
	pCONNECTOR->Set_pin(PIN_SEL1	,READ_BIT(port2,0));
	pCONNECTOR->Set_pin(PIN_MT_OUT1	,pCPU->Get_Xout());

	// MANAGE SERIAL CONNECTOR
	pSIOCONNECTOR->Set_pin(SIO_SD	,GET_PORT_BIT(PORT_F,2));
	pSIOCONNECTOR->Set_pin(SIO_RR	,READ_BIT(port1,2));
	pSIOCONNECTOR->Set_pin(SIO_RS	,READ_BIT(port1,3));
	pSIOCONNECTOR->Set_pin(SIO_ER	,READ_BIT(port1,1));

	return(1);
}

bool Cpc1360::Get_Connector(void)
{
	Set_Port_Bit(PORT_B,4,pCONNECTOR->Get_pin(PIN_D_IN));	// DIN	:	IB8
	Set_Port_Bit(PORT_B,5,pCONNECTOR->Get_pin(PIN_ACK));	// ACK	:	IB7
	pCPU->Set_Xin(pCONNECTOR->Get_pin(PIN_MT_IN));


	// MANAGE SERIAL CONNECTOR
	Set_Port_Bit(PORT_B,6,pSIOCONNECTOR->Get_pin(SIO_RD));
	Set_Port_Bit(PORT_B,7,pSIOCONNECTOR->Get_pin(SIO_CS));
	Set_Port_Bit(PORT_B,8,pSIOCONNECTOR->Get_pin(SIO_CD));
//	Set_Port_Bit(PORT_A,8,pSIO->pSIOCONNECTOR->Get_pin(SIO_PAK));		
	// PAK

	return(1);
}

BYTE	Cpc1360::Get_PortB(void)
{
	return (IO_B);
}

void	Cpc1360::Set_PortF(BYTE data)
{
	IO_F = data;
	RamBank = GET_PORT_BIT(PORT_F,3);
}

void	Cpc1360::Set_PortC(BYTE data)
{
	IO_C = data;
}

bool Cpc1360::Chk_Adr(DWORD *d,DWORD data)
{
	if ( (*d>=0x0000) && (*d<=0x1FFF) )	{ return(0); }	// ROM area(0000-1fff) 
	if ( (*d>=0x2000) && (*d<=0x27FF) )	{ return(0); }
	if ( (*d>=0x2800) && (*d<=0x33FF) ) { pLCDC->SetDirtyBuf(*d-0x2800); return(1);			/* LCDC (0200x) */	}
	if ( (*d>=0x3400) && (*d<=0x35FF) )	{ RomBank = data &0x07;	return(1); }
	if ( (*d>=0x3E00) && (*d<=0x3FFF) )
	{
		int K=0;

		switch (data & 0x0F)
		{
			case 0x00: K=0x00;	break;
			case 0x01: K=0x01;	break;
			case 0x02: K=0x02;	break;
			case 0x03: K=0x04;	break;
			case 0x04: K=0x08;	break;
			case 0x05: K=0x10;	break;
			case 0x06: K=0x20;	break;
			case 0x07: K=0x40;	break;
			case 0x08: K=0x80;	break;
			case 0x09: K=0x00;	break;
			case 0x0A: K=0x00;	break;
			case 0x0B: K=0x00;	break;
			case 0x0C: K=0x00;	break;
			case 0x0D: K=0x00;	break;
			case 0x0E: K=0x00;	break;
			case 0x0F: K=0x7F;	break;
		}

		pKEYB->Set_KS( K );

		return(1);
	}

#if 0
	if ( (*d>=0x3C00) && (*d<=0x3DFF) )
	{
		AddLog(LOG_MASTER,tr("Write Slot Register %1=%2").arg(*d).arg(mem[*d]));	
		RamBank = (data == 0x04 ? 0 : 1);
		return(1);
	}
#endif

	if ( (*d>=0x2800) && (*d<=0x3FFF) )	return(1);
	if ( (*d>=0x4000) && (*d<=0x7FFF) )	{ *d += 0xC000 + ( RomBank * 0x4000 );	return(0); }

	if ( (*d>=0x8000) && (*d<=0xFFFF) )
	{
		*d += 0x28000 + (RamBank * 0x8000);
		if ( (*d>=0x30000) && (*d<=0x33FFF) )	return(S1_EXTENSION_CE2H32M_CHECK);
		if ( (*d>=0x34000) && (*d<=0x35FFF) )	return(S1_EXTENSION_CE2H32M_CHECK | S1_EXTENSION_CE2H16M_CHECK);
		if ( (*d>=0x36000) && (*d<=0x36FFF) )	return(S1_EXTENSION_CE2H32M_CHECK | S1_EXTENSION_CE2H16M_CHECK | S1_EXTENSION_CE212M_CHECK);
		if ( (*d>=0x37000) && (*d<=0x377FF) )	return(S1_EXTENSION_CE2H32M_CHECK | S1_EXTENSION_CE2H16M_CHECK | S1_EXTENSION_CE212M_CHECK | S1_EXTENSION_CE211M_CHECK);
		if ( (*d>=0x37800) && (*d<=0x37FFF) )	return(S1_EXTENSION_CE2H32M_CHECK | S1_EXTENSION_CE2H16M_CHECK | S1_EXTENSION_CE212M_CHECK | S1_EXTENSION_CE211M_CHECK | S1_EXTENSION_CE210M_CHECK);

		if ( (*d>=0x38000) && (*d<=0x3BFFF) )	return(S2_EXTENSION_CE2H32M_CHECK);
		if ( (*d>=0x3C000) && (*d<=0x3DFFF) )	return(S2_EXTENSION_CE2H32M_CHECK | S2_EXTENSION_CE2H16M_CHECK);
		if ( (*d>=0x3E000) && (*d<=0x3EFFF) )	return(S2_EXTENSION_CE2H32M_CHECK | S2_EXTENSION_CE2H16M_CHECK | S2_EXTENSION_CE212M_CHECK);
		if ( (*d>=0x3F000) && (*d<=0x3F7FF) )	return(S2_EXTENSION_CE2H32M_CHECK | S2_EXTENSION_CE2H16M_CHECK | S2_EXTENSION_CE212M_CHECK | S2_EXTENSION_CE211M_CHECK);
		if ( (*d>=0x3F800) && (*d<=0x3FFFF) )	return(S2_EXTENSION_CE2H32M_CHECK | S2_EXTENSION_CE2H16M_CHECK | S2_EXTENSION_CE212M_CHECK | S2_EXTENSION_CE211M_CHECK | S2_EXTENSION_CE210M_CHECK);
		
	}

	return(0);
}


bool Cpc1360::Chk_Adr_R(DWORD *d,DWORD data)
{
	// Manage ROM Bank
	if ( (*d>=0x4000) && (*d<=0x7FFF) )	{ *d += 0xC000 + ( RomBank * 0x4000 ); return (1); }
	// Manage ram bank
	if ( (*d>=0x8000) && (*d<=0xFFFF) )	{ *d += 0x28000 + ( RamBank * 0x8000 ); return (1);}
	

	return(1);
}


